/* ========================================================================== *
 * Module      : HtmlComb.h                                                   *
 * Description : Header file for the HtmlComb library.                        *
 * Version     : 1.0.0 05/Mar/2004                                            *
 * ========================================================================== */

#ifndef _LIB_HTMLCOMB_H
#define _LIB_HTMLCOMB_H

# include <stdio.h>
# include <stdlib.h>
# include <stdarg.h>
# include "Prelude.h"
# include "html.h"
# include "html_cata.h"

/*
  HtmlLst   : NoHtmlLst ()
            | ConsHtmlLst (Html HtmlLst)
            ;
  Html      : NoHtml   ()
            | ConsHtml (HtmlEl Html)
            ;
  HtmlEl    : ConsHtmlText (STR)
            | ConsHtmlTag (STR HtmlAttrs Html STR)
            ;
  HtmlAttrs : NoHtmlAttrs()
            | ConsHtmlAttrs(HtmlAttr HtmlAttrs)
            ;
  HtmlAttr  : ConsHtmlAttr (STR STR)
            ;
*/

/* == Combinators =========================================================== */

Html html_text (char *);
Html html_tag (char *, Html);
Html html_tagWithAttrs (char *, HtmlAttrs, Html);
HtmlAttr html_attr (char *, char *);
Html html_font (Html); 
Html html_bold (Html); 
Html html_italic (Html); 
Html html_emph (Html); 
Html html_hline (void); 
Html html_par (Html); 
Html html_br(void); 
Html html_space (void); 
Html html_center (Html); 
Html html_table (Html);
Html html_row (Html);
Html html_rowWithAttrs (HtmlAttrs,Html);
Html html_elem (Html);
Html html_elemWithAttrs (HtmlAttrs,Html);
HtmlAttr html_aleft (void);
HtmlAttr html_aright (void);
HtmlAttr html_acenter (void);
Html html_link (char *,Html);
Html html_image (char *,Html);
Html html_itemize (Html);
Html html_item (Html);

string unparse_HtmlLst(HtmlLst) ;
string unparse_Html(Html) ;

T _u_f0_ (void);
T _u_f1_ (HtmlEl,T);
T _u_f2_ (char *);
T _u_f3_ (char *,HtmlAttrs,Html,char *);
T _u_f4_ (void);
T _u_f5_ (HtmlAttr,T);
T _u_f6_ (char *,char *);
#endif
/* ========================================================================== */
