/*
  LRC_DEFINE_NONT(nont_id, number, num prods, first prod, entry token, scan state, entry attr )

  LRC_DEFINE_PROD(prod_id,global prod number, number of sons, lhs nt)
*/

#define LRC_NO_IG_ENTRY (-1)
#define LRC_NO_SCAN_STATE ""
#define LRC_NO_IG_ENTRY_ATTR "" 
#define LRC_NO_VISIT (-1)

#define LRC_DEFINE_NONT(nont_id,glob_num,num_prods,first_prod,entry_token,scan_state,entry_attr,first_vnt_ix,num_visits)\
lrc_define_nonterminal(#nont_id,glob_num,num_prods,entry_token,scan_state,entry_attr,first_vnt_ix,num_visits);

#define LRC_DEFINE_ROOT(root_number) lrc_define_root(root_number);

#define LRC_DEFINE_PROD(prod_id,glob_num,num_sons,lhs_nt)\
lrc_define_constructor(#prod_id,glob_num,num_sons,lhs_nt);

#define LRC_DEFINE_WRAPPER(wrap_id,glob_num,num_sons)\
LRC_DEFINE_PROD(wrap_id,glob_num+NUM_PRODUCTIONS,num_sons,-1)

#include "code.siz"
#include <string.h>
#include <lrclib.h>
#include <EVALUATOR/evaluator.h>
#include "bcode.ttm"
#include "bcode.htc"
#include "bcode.tab.h"

static void init_agd(void) {
 #include "code.agd"
}

static void init_wrd(void) {
 #include "code.wrd"
}


#ifdef V2C_CODE
typedef struct { char * name; int index; } lrc_packet_attrs;
#include "code.rpk"
static int in_packet_index(char * attr_name) {
  int ix=0;
  while (lrc_root_in_attributes[ix].name!=0) {
    if (strcmp(attr_name,lrc_root_in_attributes[ix].name)==0)
         return lrc_root_in_attributes[ix].index;
    ix++;
  }
  return -1;
}

static int out_packet_index(char * attr_name) {
  int ix=0;
  while (lrc_root_out_attributes[ix].name!=0) {
    if (strcmp(attr_name,lrc_root_out_attributes[ix].name)==0) return ix;
    ix++;
  }
  return -1;
}

void lrc_set_ip_attr(lrc_term *ip, char * name, lrc_term attr_value) {
  int ix;
  ix=in_packet_index(name);
  if (ix==-1) return;
  ip[ix]=attr_value;
}

lrc_term lrc_get_op_attr(char * name, lrc_term *op) {
  int ix;
  ix=out_packet_index(name);
  if (ix==-1) return 0;
  return op[ix];
}

char * lrc_root_op_attr_name(int attr_num) {
  int ix=0;
  while (lrc_root_out_attributes[ix].name!=0) {
    if (lrc_root_out_attributes[ix].index==attr_num) return lrc_root_out_attributes[ix].name;
    ix++;
  }
  return 0;
}

#endif

#ifdef COMPLETING_PLACEHOLDER
#define DEFINE_COMPLETING(nont_id,expr) lrc_nont_set_completing_term(lrc_id_to_nont(#nont_id),expr);
#define DEFINE_PLACEHOLDER(nont_id,expr) lrc_nont_set_placeholder_term(lrc_id_to_nont(#nont_id),expr);
void init_completing_placeholder (void) {
#include "bcode.cpt"
}
#endif

#if VISUAL==2
#include "bcode.ebh"
void init_event_binding_tables() {
#include "bcode.ebi"
}
#endif

void init_grammar_tables(void) {
  lrc_alloc_grammar_tables(NUM_NTS,NUM_PRODUCTIONS,NUM_WRAPPERS);
  lrc_alloc_visit_table(NUM_VPRS,NUM_VNTS);
  init_agd();
  init_wrd();
#ifdef COMPLETING_PLACEHOLDER
  init_completing_placeholder();
#endif
  fill_visit_tables();
}

