typedef struct id   { char * ident; int id_code; } identifier_tp;
typedef struct nont { char * nont_id; }  nont_tp;
typedef struct prod { char * prod_id; short num_ntoccs; short first_ntocc; } prod_tp;
typedef struct nocc 
 { short number; short prod; short nont; short multiplicity; short is_nta; } nocc_tp;

typedef enum { INH, SYN, LOCAL } attr_kind_tp;
typedef struct attr { short ident_num;  attr_kind_tp kind; short prod_nont; } attr_tp;
typedef enum { AO_NORMAL, AO_LOCAL, AO_NTA_SR, AO_ANY } aocc_kind_tp;
/* kind AO_ANY is used in pattern matching; no aocc has this kind */
typedef struct aocc { aocc_kind_tp kind; short prod_ntocc; short attribute; short defining_eq; } aocc_tp;
typedef struct eq   { short destination; } eq_tp;

typedef struct ag_data {
  char * ag_name;
  int num_attr_idents;
  identifier_tp * ag_attr_idents;
  int       num_nonterminals;
  nont_tp * nonterminals;
  int       num_productions;
  prod_tp * productions;
  int       num_ntoccs;
  nocc_tp * ntoccs;
  int       num_attributes;
  attr_tp * attributes;
  int       num_aoccs;
  aocc_tp * aoccs;
  int       num_eqs;
  eq_tp   * eqs;
 } ag_rec_tp, * p_ag_rec_tp;


void allocate_attr_identifier_data(int num_idents);
void define_attr_ident(int ix, int id_code, char * s);
void print_attr_idents(void);
char * index_ident_table(int ix);
void allocate_nonterminal_data(int num_nts);
void allocate_production_data(int num_prods);
void allocate_ntocc_data(int num_noccs);
void allocate_attribute_data(int num_attrs);
void allocate_aocc_data(int num_aoccs);
void allocate_eq_data(int num_eqs);
void enter_nonterminal(int number, char * id);
void enter_production(char * id, int number, int num_ntoccs, int first_ntocc) ;
void enter_ntocc(int number, int prod, int nont, int multiplicity, int is_nta );
void enter_attribute(int ident_num, int number, int prod_nont, attr_kind_tp kind);
void enter_aocc_a(int number, int lntocc, int attr);
void enter_aocc_l(int number, int prod, int attr);
void enter_aocc_n(int number, int ntocc);
void enter_eq(int number, int destination);

int ag_num_productions(void);
int ag_num_nonterminals(void);
int ag_num_ntoccs(void);
int ag_num_attributes(void);
int ag_num_aoccs(void);
int ag_num_equations(void);

char *       nont_id(short nont);

short        ntocc_nont         (short ntocc);
short        ntocc_multiplicity (short ntocc);
short        ntocc_prod         (short ntocc);
char *       ntocc_id           (short ntocc);

char *       prod_id(short prod);
short        prod_num_ntoccs(short prod);
short        prod_first_ntocc(short prod);
short        prod_nth_ntocc(short prod, int n);

char *       attr_id  (short attr);
short        attr_nont(short attr);
short        attr_prod(short attr);
attr_kind_tp attr_kind(short attr);

aocc_kind_tp aocc_kind(short aocc);
int          aocc_is_nta (short aocc);
short        aocc_attr   (short aocc);
short        aocc_nocc   (short aocc);
short        aocc_prod   (short aocc);

short        eq_destination(short eq);
short        aocc_defining_eq(short aocc);

void ag_print_prod(short prod);
void ag_print_aocc(short aocc);
void ag_print_equations(void);
int ag_check_tables(void);



