#include <stdio.h>
#include <string.h>

#include "lrcmemory.h"
#include "ag_table.h"
#include "aoccpats.h"

/* With each equation we associate actions
 * that support debugging.
 * The actiosn associated with equation eq is recorded in eq_trace_table[eq]
 * Possible values of the action are
 *    0    : no tracing of this equation
 *    'P'  : print value of destination of equation
 */

#define EQ_TRACE_NONE '\0'
#define EQ_TRACE_PRINT 'P'

static char * eq_trace_table;

void allocate_eq_trace_data(int num_eqs) {
  eq_trace_table=(char *)lrc_malloc(num_eqs*sizeof(*(eq_trace_table)));
}

void eq_set_trace_status(int eq, char status) {
  eq_trace_table[eq]=status;
}

char eq_trace_status(int eq) {
  return eq_trace_table[eq];
}

static void eq_set_print_status(int eq) {
  /** printf("SETTING PRINT STATUS OF EQUATION '%d'\n",eq); **/
  eq_set_trace_status(eq,EQ_TRACE_PRINT);
}

void eqs_set_print_matching(aocc_pattern_tp pat) {
  all_matching_equations(pat,eq_set_print_status);
}

void eqs_set_tracing(char * pattern) {
  eqs_set_print_matching(string_to_aocc_pattern(pattern));
}

char aocc_trace_status(int aocc) {
  int eq=aocc_defining_eq(aocc);
  if (eq==-1) return EQ_TRACE_NONE;
  return eq_trace_status(eq);
}

