typedef lrc_bool lrc_eb_match_function_tp(lrc_term,lrc_term,lrc_term);
typedef lrc_term lrc_eb_trafo_function_tp(lrc_term,lrc_term,lrc_term);

typedef struct trafo_entry {
  lrc_eb_trafo_function_tp *trafo_function;
} trafo_entry_tp, *trafo_table_tp;

typedef  struct binding_entry {
  lrc_eb_match_function_tp *match_function;
  int num_trafos;
  trafo_entry_tp *trafos;
} binding_entry_tp, *binding_table_tp;

void init_event_bindings(void);
void create_binding_table(int num_bind_constructs);
void define_binding(int bind_key, int num_trafos);
void set_binding_match_function(int bind_key, lrc_eb_match_function_tp match_function);
void set_binding_trafo_function(int bind_key, int trafo_key, lrc_eb_trafo_function_tp trafo_function);
int binding_num_trafos(int bind_key);
lrc_bool invoke_matcher(int bind_key, lrc_term event, lrc_term frame, lrc_term parameters);
lrc_term invoke_transformation(int bind_key, int trafo_key,
                               lrc_term event, lrc_term frame, lrc_term parameters);


lrc_term _lrc_add_bind(
   int binding_key, lrc_term match_parameters, lrc_term trafo_data, lrc_term instances);
lrc_term lrc_all_matches(lrc_term event, lrc_term frame, lrc_term instances);
int is_empty_bindings(lrc_term instances);


int instance_binding_number(lrc_term bi);
lrc_term instance_match_parameters(lrc_term bi);
lrc_term instance_trafo_data(lrc_term bi);
lrc_term bind_trafo_subtree_reference(lrc_term bt);
lrc_term bind_trafo_parameters(lrc_term bt);
int is_empty_trafo_data(lrc_term td_list);


