/*
** maps.h
** april 1994 by Maarten Pennings
** Original by Matthijs Kuiper
** generated from headers.noweb
*/

#include "shalloc.h"
#include "avl.h"

typedef struct lrc_map {
  lrc_term              default_value;
  AVL_tp                avl;
  equal_function_tp   * equal_key;
  compare_function_tp * compare_key;
  equal_function_tp   * equal_value;
  compare_function_tp * compare_value;
} lrc_map;

#define T__Map 7

  lrc_term C_Map(lrc_map);
       int lrc_map_compare(lrc_map, lrc_map); 
       int lrc_map_compare_term(lrc_term, lrc_term); 
  lrc_bool lrc_map_equal(lrc_map, lrc_map);
  lrc_bool lrc_map_equal_term(lrc_term, lrc_term);
      void lrc_map_print(lrc_map, void print_key(), void print_value());
      void mark_map(lrc_term);

extern lrc_map lrc_empty_map(
      equal_function_tp *,
      compare_function_tp *,
      equal_function_tp *,
      compare_function_tp *,
      lrc_term
   );

  lrc_term lrc_map_application  (lrc_term, lrc_map);
  lrc_bool lrc_map_in           (lrc_term, lrc_map);
   lrc_map lrc_map_single_update(lrc_term, lrc_term, lrc_map);
   lrc_map lrc_map_update       (lrc_map,  lrc_map);
   lrc_map lrc_map_init         (lrc_map,  lrc_term, int);

      void map_forall(lrc_map m, void action());
      void map_forall_keys(lrc_map m, void action());
       int map_num_keys(lrc_map m);


