#include <string.h>
#include <stdio.h>
#include "strs.h"
#include "parse_support.h"

static lrc_parse_state_tp parse_state;
static int pos_line;
static int pos_col;

lrc_parse_state_tp lrc_parse_state() {
  return parse_state;
}

void lrc_get_parse_position(int *line, int *col) {
  *line=pos_line;
  *col=pos_col;
}

void lrc_set_parse_state(lrc_parse_state_tp s) {
 parse_state=s;
}


static void update_position(char * yytext) {
  char *s;
  s=yytext;
  /** printf("update_position %d.%d + '%s'", pos_line, pos_col, s); **/
  while (*s) {
     if (*s=='\n') { pos_line++; pos_col=0; }
     else { pos_col++; }
     s++;
  }
  /** printf(" -> %d.%d\n", pos_line, pos_col); **/
}

void lrc_clear_parse_position() {
  pos_line=1;
  pos_col=0;
}

lrc_string lrc_extract_token(char * yytext) {
  update_position(yytext);
  return strdup(yytext);
}

void lrc_process_whitespace(char * yytext) {
  update_position(yytext);
}
/*************
StringParser * string_parser=0;

void lrc_set_string_parser(StringParser parser) {
  string_parser=parser;
}

lrc_term lrc_parse_string(lrc_string s, int nt) {
  if (string_parser==0) { return 0; }
  return string_parser(s,nt);
}
****************/
