/*
** ptrs.c
** april 1994 by Maarten Pennings
** Library functions by Matthijs Kuiper
*/

#include <stdio.h>
#include "ints.h"
#include "ptrs.h"

static lrc_term_ix index_ptr(lrc_ptr p) {
  return abs((int)p+T__Ptr)%lrc_term_tabelsize;
}

static lrc_bool eq_ptr(lrc_term t,lrc_ptr b) {
  /*
  return LRC_TAG(t)==FIELD(b,0,int) && 
         LRC_VALUE(t,int)==FIELD(b,sizeof(lrc_ptr),int);
  */
  return (t==(lrc_term)b);
}

lrc_term C_Ptr(lrc_ptr p) {
 /*
  struct {lrc_ptr tag;lrc_ptr p;} buf;
  buf.tag=(lrc_ptr)T__Ptr; buf.p=p;
  return lrc_shared_prim(index_ptr(p),eq_ptr,sizeof(buf),&buf);
  */
  return (lrc_term)p;
}

/*********************\
** Library functions **
\*********************/

int lrc_ptr_compare(lrc_ptr a, lrc_ptr b) {
  return ((int)a<(int)b) ? lrc_less : (((int)a==(int)b)?lrc_equal:lrc_greater);
}

int lrc_ptr_compare_term(lrc_term a, lrc_term b) {
  return lrc_ptr_compare(LRC_VALUE(a,lrc_ptr),LRC_VALUE(b,lrc_ptr));
}

lrc_bool lrc_ptr_equal(lrc_ptr a, lrc_ptr b) {
  return (a==b);
}

lrc_bool lrc_ptr_equal_term(lrc_term a, lrc_term b) {
  return lrc_ptr_equal(LRC_VALUE(a,lrc_ptr),LRC_VALUE(b,lrc_ptr));
}

const lrc_ptr lrc_nil=0;

lrc_ptr lrc_ptr_default(void) { return (lrc_ptr)C_Int(0); }

