/*
** shalloc.h
** january 1994 by Maarten Pennings
** generated from headers.noweb
*/

#ifndef _LRC_SHALLOC_INCLUDED
#define _LRC_SHALLOC_INCLUDED
#define FAT

#include "basics.h"

void lrc_term_init(void);

/* A prime p that can not be written as (2^k)-1 
** some primes 11,101,1009,10007,100003 */
#define lrc_term_tabelsize 100003

typedef unsigned int lrc_term_ix;

#define FIELD(buf,offset,type)   (*(type*)((int)(buf)+offset))

/****************************************************\
** Low level implementation (cell is just anything) **
\****************************************************/

typedef lrc_bool lrc_selector(int,lrc_ptr,int,int,lrc_ptr);

lrc_ptr lrc_shalloc(lrc_term_ix i,lrc_selector eq,int size,int sons,lrc_ptr buf);

/***********************************************************************\
**  High level interface (cell is list of pointers, first used as tag) **
\***********************************************************************/

typedef lrc_ptr *lrc_term;
#ifdef FAT
#define LRC_USER_FIELDS_OFFSET 6
#else
#define LRC_USER_FIELDS_OFFSET 3
#endif
#define LRC_USER_DATA(term) ((term)+LRC_USER_FIELDS_OFFSET)
#define LRC_USER_FIELD(typ,term,fnum) ((typ)((term)[LRC_USER_FIELDS_OFFSET+fnum]))
#define LRC_TAG(t)            LRC_USER_FIELD(int,t,0)
#define LRC_CHILD(t,i)        LRC_USER_FIELD(lrc_term,t,i)

#define LRC_ADDRESS_PRIMITIVE(term) ((lrc_term)(term)+1+LRC_USER_FIELDS_OFFSET)
#define LRC_VALUE_GENERAL(term,type)  (*(type*)(LRC_ADDRESS_PRIMITIVE(term)))

#define LRC_VALUE_int(t) LRC_VALUE_GENERAL(t,int)
#define LRC_VALUE_char(t) LRC_VALUE_GENERAL(t,char)
#define LRC_VALUE_lrc_bool(t) LRC_VALUE_GENERAL(t,lrc_bool)
#define LRC_VALUE_lrc_string(t) LRC_VALUE_GENERAL(t,lrc_string)
#define LRC_VALUE_lrc_map(t) LRC_VALUE_GENERAL(t,lrc_map)
#define LRC_VALUE_lrc_attr(t) LRC_VALUE_GENERAL(t,lrc_attr)
/* #define LRC_VALUE_lrc_ptr(t) LRC_VALUE_GENERAL(t,lrc_ptr) */
#define LRC_VALUE_lrc_ptr(t) t

#define LRC_VALUE_lrc_real(t) lrc_value_real(t)

#define LRC_VALUE(t,type)     LRC_VALUE_ ## type(t)

void lrc_all_terms_in_cache(void action(lrc_term));

void remove_unmarked_terms(void);

#ifdef TRACE
void define_term_tracer(void tracer());
#endif
 
void lrc_term_register_hit(lrc_ptr); 
typedef lrc_bool lrc_comparer(lrc_term,lrc_ptr);
lrc_term lrc_shared_prim(lrc_term_ix i,lrc_comparer eq,int size,lrc_ptr buf);

lrc_term lrc_shared_cons(int size,lrc_term buf);


/****************\
**  Diagnostics **
\****************/

int  lrc_term_time(void);

int lrc_term_hashix(lrc_term);
int lrc_term_hits(lrc_term);
int lrc_term_birth(lrc_term);
int lrc_term_nnodes(lrc_term t);
int lrc_term_size(lrc_term t);
int lrc_term_occupied_size(lrc_term t);
int lrc_term_mark(lrc_term t);

typedef void lrc_term_printer(lrc_term);
typedef lrc_bool lrc_term_filter(lrc_term);

void lrc_term_dump_set_birth_time(int);
void lrc_term_dump(lrc_term_filter,lrc_term_printer);
void lrc_term_stats(int level);



#endif

