/*
** term.c
** january 1998 (Matthijs Kuiper)

*/

#include <memory.h>
#include <stdio.h>
#include <stdarg.h>
#include "data_layout.h"
#include "maps.h"
#include "shalloc.h"

#include "lrcmemory.h"
#include "prims.h"
#include "memo.h"
#include "grammar_tables.h"

#define LRC_SHALLOC(t)        lrc_shared_cons(sizeof(t),(lrc_term)&t)


/* Constructors */

lrc_term lrc_term0(int tg){
  lrc_term res[1];
  res[0]=(lrc_term)tg;
  return LRC_SHALLOC(res);
}

lrc_term lrc_term1(int tg,lrc_term c1){
  lrc_term res[2];
  res[0]=(lrc_term)tg;
  res[1]=c1;
  return LRC_SHALLOC(res);
}

lrc_term lrc_term2(int tg,lrc_term c1 ,lrc_term c2){
  lrc_term res[3];
  res[0]=(lrc_term)tg;
  res[1]=c1;
  res[2]=c2;
  return LRC_SHALLOC(res);
}

lrc_term lrc_term3(
      int tg,
      lrc_term c1 ,lrc_term c2, lrc_term c3
  ){
  lrc_term res[4];
  res[0]=(lrc_term)tg;
  res[1]=c1;
  res[2]=c2;
  res[3]=c3;
  return LRC_SHALLOC(res);
}

lrc_term lrc_term4(
      int tg,
      lrc_term c1 ,lrc_term c2, lrc_term c3, lrc_term c4
  ){
  lrc_term res[5];
  res[0]=(lrc_term)tg;
  res[1]=c1;
  res[2]=c2;
  res[3]=c3;
  res[4]=c4;
  return LRC_SHALLOC(res);
}

lrc_term lrc_term5(
      int tg,
      lrc_term c1 ,lrc_term c2, lrc_term c3, lrc_term c4, lrc_term c5
  ){
  lrc_term res[6];
  res[0]=(lrc_term)tg;
  res[1]=c1;
  res[2]=c2;
  res[3]=c3;
  res[4]=c4;
  res[5]=c5;
  return LRC_SHALLOC(res);
}

lrc_term lrc_term6(
      int tg,
      lrc_term c1 ,lrc_term c2, lrc_term c3, lrc_term c4, lrc_term c5,
      lrc_term c6
  ){
  lrc_term res[7];
  res[0]=(lrc_term)tg;
  res[1]=c1;
  res[2]=c2;
  res[3]=c3;
  res[4]=c4;
  res[5]=c5;
  res[6]=c6;
  return LRC_SHALLOC(res);
}

lrc_term lrc_term7(
      int tg,
      lrc_term c1 ,lrc_term c2, lrc_term c3, lrc_term c4, lrc_term c5,
      lrc_term c6 ,lrc_term c7
  ){
  lrc_term res[8];
  res[0]=(lrc_term)tg;
  res[1]=c1;
  res[2]=c2;
  res[3]=c3;
  res[4]=c4;
  res[5]=c5;
  res[6]=c6;
  res[7]=c7;
  return LRC_SHALLOC(res);
}

lrc_term lrc_term8(
      int tg,
      lrc_term c1 ,lrc_term c2, lrc_term c3, lrc_term c4, lrc_term c5,
      lrc_term c6 ,lrc_term c7, lrc_term c8
  ){
  lrc_term res[9];
  res[0]=(lrc_term)tg;
  res[1]=c1;
  res[2]=c2;
  res[3]=c3;
  res[4]=c4;
  res[5]=c5;
  res[6]=c6;
  res[7]=c7;
  res[8]=c8;
  return LRC_SHALLOC(res);
}

lrc_term lrc_term9(
      int tg,
      lrc_term c1 ,lrc_term c2, lrc_term c3, lrc_term c4, lrc_term c5,
      lrc_term c6 ,lrc_term c7, lrc_term c8, lrc_term c9
  ){
  lrc_term res[10];
  res[0]=(lrc_term)tg;
  res[1]=c1;
  res[2]=c2;
  res[3]=c3;
  res[4]=c4;
  res[5]=c5;
  res[6]=c6;
  res[7]=c7;
  res[8]=c8;
  res[9]=c9;
  return LRC_SHALLOC(res);
}

lrc_term lrc_term10(
      int tg,
      lrc_term c1 ,lrc_term c2, lrc_term c3, lrc_term c4, lrc_term c5,
      lrc_term c6 ,lrc_term c7, lrc_term c8, lrc_term c9, lrc_term c10
  ){
  lrc_term res[11];
  res[0]=(lrc_term)tg;
  res[1]=c1;
  res[2]=c2;
  res[3]=c3;
  res[4]=c4;
  res[5]=c5;
  res[6]=c6;
  res[7]=c7;
  res[8]=c8;
  res[9]=c9;
  res[10]=c10;
  return LRC_SHALLOC(res);
}

lrc_term lrc_termhuge(int tg,...) {
  va_list ap;
  int num_children=lrc_constructor_num_sons(tg);
  lrc_term *res;
  int i;

  res = (lrc_term *)lrc_malloc((1+num_children)*sizeof(*res));
  res[0]=(lrc_term)tg;
  va_start(ap,tg);
  for(i=1;i<=num_children;i++) {
    res[i]=va_arg(ap,lrc_term);
  }
  va_end(ap);
  
  return lrc_shared_cons((1+num_children)*sizeof(*res),(lrc_term)res);
}

lrc_term lrc_build_term(char * prod_name,...) {
  va_list ap;
  int tg;
  int num_children;
  lrc_term *res;
  int i;
 
  tg = lrc_prod_name_to_tag(prod_name);
  num_children=lrc_constructor_num_sons(tg);
  res = (lrc_term *)lrc_malloc((1+num_children)*sizeof(*res));
  res[0]=(lrc_term)tg;
  va_start(ap,prod_name);
  for(i=1;i<=num_children;i++) {
    res[i]=va_arg(ap,lrc_term);
  }
  va_end(ap);
  
  return lrc_shared_cons((1+num_children)*sizeof(*res),(lrc_term)res);
}

/* marking and deleting entries from the constructor cache
 */

/* TERRIBLE HACK: redefing T__Map
 */

#define T__Map 7
void mark_term(lrc_term t) {
  int i;
  int num_children;
  if (MARK(t)) return;
  MARK(t)=1;
  if (LRC_TAG(t)==T__Map) {
    mark_map(t);
    return;
  }
  num_children=lrc_constructor_num_sons(LRC_TAG(t));
  for (i=1;i<=num_children;i++) mark_term(LRC_CHILD(t,i));
}


