/**
 **  WARNING: DO NOT EDIT THIS FILE.
 **
 **   This is generated code.
 **/
#include <stdio.h>
#include "shalloc.h"
#include "term.h"
#include "initial.h"
#include "prims.h"
#include "strs.h"
#include "textbuffer.h"
#include "position.h"
#include "unparse_tables.h"
#include "view_tables.h"
#include "reference.h"
#include "fragments.h"
#include "views.h"
#include "ints.h"
#include "reals.h"
#include "maps.h"
#include "style.h"
#include "foreign.h"
#include "grammar_tables.h"
#include "decoration.h"
#include "visit_tables.h"
#include "unparser.h"

#ifndef TRACE_UNPARSER
#define TRACE_UNPARSER 0
#endif

#define TRACE_START if(TRACE_UNPARSER) {
#define TRACE_END   }


#define MAX_STYLE_NAME_LENGTH 200

#define check_tag(prod_name) if (T_ ## prod_name==-1) { report_undefined_prod(#prod_name); result=0; }
#define define_tag(prod_name) T_ ## prod_name=lrc_prod_name_to_tag(#prod_name); check_tag(prod_name);

#define C_LRC_ATTRS0() lrc_term0(T__LRC_ATTRS0)
#define C_LRC_ATTRS2(c_1,c_2) lrc_term2(T__LRC_ATTRS2,C_Ptr(c_1),c_2)
#define C_LRC_NODES0() lrc_term0(T__LRC_NODES0)
#define C_LRC_NODES2(c_1,c_2) lrc_term2(T__LRC_NODES2,c_1,c_2)
#define C_LRC_UAT_A(c_1) lrc_term1(T__LRC_UAT_A,c_1)
#define C_LRC_UAT_C(c_1) lrc_term1(T__LRC_UAT_C,c_1)
#define C_LRC_UAT_CA(c_1,c_2) lrc_term2(T__LRC_UAT_CA,c_1,c_2)
#define C_LRC_UAT_NO() lrc_term0(T__LRC_UAT_NO)

static StyleList text_styles;
static output_state_tp output_state;

static char *style_name;
static int style_name_length;

static int INTERPRETE_TREE_STRING=0;

static int T__LRC_ATTRS0,
  T__LRC_ATTRS2,
  T__LRC_NODES0,
  T__LRC_NODES2,
  T__LRC_UAT_A,
  T__LRC_UAT_C,
  T__LRC_UAT_CA,
  T__LRC_UAT_NO;

void unparser_install_attributes(lrc_term ual, char * name) {
}

void unparser_add_style(Style st) {
  if (st==0) return;
  text_styles=add_style(st,text_styles);
}

void unparser_init_text_styles(void) {
  Style st;
  text_styles=0;

  
  st=style_create("BASESTYLE");
  style_define_property(st,"font", "{courier 10}");
  style_define_property(st,"background","white");
  style_define_property(st,"foreground","black");
  unparser_add_style(st);

  st=style_create("fixed");
  text_styles=add_style(st,text_styles);
  style_define_property(st,"font", "-*-courier-*-r-*-*-*-140-*-*-*-*-*-*");
  style_define_property(st,"background","red");
  style_define_property(st,"foreground","white");
  unparser_add_style(st);
}

StyleList unparser_get_text_styles(void) {
  return text_styles;
}

Style unparser_obtain_text_style(lrc_string style_name) {
  Style st;
  st=get_style(style_name,unparser_get_text_styles());
  if (st==0) st=style_read_from_file(style_name,lrc_string_concat(style_name,".sty"));
  if (st==0) {
    st=style_create(style_name);
    /** return 0; **/
  }
  unparser_add_style(st);
  return st;
}

static void interprete_string(
  lrc_term str_tree, int command_index, char * command_string, Fragments fr) {

  int ignore_percent; /* do we treat percent as a plain character or as a command-start character */
  char * s;
  int sub_length;   /* length of substring we are processing */
  int sub_offset;   /* offset of first char of plain substring */
  int char_offset;  /* offset of character c in s */ 

  if (str_tree!=0) {
    if (LRC_TAG(str_tree)==T__Str) {
      s=LRC_VALUE_lrc_string(str_tree);
    }
    else {
      s=(lrc_string)ALLOC_STR(2*sizeof(*s));
      s[0]=LRC_VALUE_char(str_tree);
      s[1]='\0';
    }
  }
  else {
    s=command_string;
  }

  ignore_percent=str_tree!=0 && !INTERPRETE_TREE_STRING;


  char_offset=0;
  sub_length=0;
  sub_offset=0;

  while (!(*s==0)) {
    char c;
    c=*s;
      switch(output_state) {
        case os_plain:
          if (c=='%' && !ignore_percent) {
           if (sub_length>0) {
             if (str_tree!=0) {
               if (LRC_TAG(str_tree)==T__Str) {
                 fr_add_tree_substring(str_tree,sub_offset,sub_length,fr);
               }
               else {
                 fr_add_tree_char(str_tree,fr);
               }
             }
             else {
               fr_add_template_substring(command_index,sub_offset,sub_length,fr);
             }
           }

            output_state=os_after_percent;
          }
          else { sub_length++; }
        break;

        case os_after_percent:
          switch(c) {
            case 't' : 
              fr_add_indent_up(fr);
              output_state=os_plain;
              sub_offset=char_offset+1;
              sub_length=0;

            break;
            case 'b' : 
              fr_add_indent_down(fr);
              output_state=os_plain;
              sub_offset=char_offset+1;
              sub_length=0;

            break;
            case 'n' :
              fr_add_line_break(fr);
              output_state=os_plain;
              sub_offset=char_offset+1;
              sub_length=0;

            break;
            case '[' : 
              fr_add_indent_up(fr);
              fr_add_open_group(fr);
              output_state=os_plain;
              sub_offset=char_offset+1;
              sub_length=0;

            break;
            case ']' : 
              fr_add_close_group(fr);
              fr_add_indent_down(fr);
              output_state=os_plain;
              sub_offset=char_offset+1;
              sub_length=0;

            break;
            case '{' :
              fr_add_open_group(fr);
              output_state=os_plain;
              sub_offset=char_offset+1;
              sub_length=0;

            break;
            case '}' :
              fr_add_close_group(fr);
              output_state=os_plain;
              sub_offset=char_offset+1;
              sub_length=0;

            break;
            case 'L' : 
              fr_add_set_indent(fr);
              output_state=os_plain;
              sub_offset=char_offset+1;
              sub_length=0;

            break;
            case '%' :
              fr_add_constant_char('%',fr);
              output_state=os_plain;
              sub_offset=char_offset+1;
              sub_length=0;

            break;
            case 'S' : 
                  output_state=os_after_ps;
            break;
            case 'o' :
               fr_add_optional_line_break(fr);
              output_state=os_plain;
              sub_offset=char_offset+1;
              sub_length=0;

            break;
            case 'c' : /* not yet implemented */
               fr_add_consistent_line_break(fr);
              output_state=os_plain;
              sub_offset=char_offset+1;
              sub_length=0;

            break;
            default : /* Unhandled OR undefined '%c' */
              fr_add_constant_char('%',fr);
              fr_add_constant_char(c,fr);
              output_state=os_plain;
              sub_offset=char_offset+1;
              sub_length=0;

            }
        break;

        case os_after_ps:
          if (c=='(') {
            style_name_length=0;
            style_name=(char *)lrc_malloc(MAX_STYLE_NAME_LENGTH*sizeof(*style_name));


            output_state=os_after_pso;
          }
          else if (c==')') {
            fr_add_pop_style(fr);
              output_state=os_plain;
              sub_offset=char_offset+1;
              sub_length=0;

          }
          else {
            fr_add_constant_char('%',fr);
            fr_add_constant_char('S',fr);
            fr_add_constant_char(c,fr);
              output_state=os_plain;
              sub_offset=char_offset+1;
              sub_length=0;

          }
         break;

        case os_after_pso:
          if (c==':') {
            style_name[style_name_length]='\0';


            fr_add_push_style(style_name,style_name_length,fr);
            output_state=os_plain;
            sub_offset=char_offset+1;
            sub_length=0;

          }
          else {
            if (style_name_length<MAX_STYLE_NAME_LENGTH-1) {
              style_name[style_name_length]=c;
              style_name_length++;
            }

          }
         break;
            
      }

    s++; char_offset++;
  }
  if (sub_length>0) {
    if (str_tree!=0) {
      if (LRC_TAG(str_tree)==T__Str) {
        fr_add_tree_substring(str_tree,sub_offset,sub_length,fr);
      }
      else {
        fr_add_tree_char(str_tree,fr);
      }
    }
    else {
      fr_add_template_substring(command_index,sub_offset,sub_length,fr);
    }
  }

}

static void interprete_template_string(int command_index, char *command_string, Fragments fr) {
  interprete_string((lrc_term)0, command_index,command_string,fr);
}

static void interprete_term_string(lrc_term str_tree, Fragments fr) {
  interprete_string(str_tree, 0, 0, fr);
}


static lrc_term _lrc_nodes_head(lrc_term frml_1)
{lrc_term cell_3;

if (LRC_TAG(frml_1)==T__LRC_NODES2) {
cell_3 = LRC_CHILD(frml_1,1);} else {
cell_3 = C_LRC_UAT_NO();}
return(cell_3);
}

static lrc_term _lrc_nodes_tail(lrc_term frml_1)
{lrc_term cell_2;

if (LRC_TAG(frml_1)==T__LRC_NODES2) {
cell_2 = LRC_CHILD(frml_1,2);} else {
cell_2 = C_LRC_NODES0();}
return(cell_2);
}


static lrc_term _lrc_nodes_nth_elem(lrc_term frml_1, int frml_2)
{  lrc_term cell_5;

  if (frml_2==1) {
    cell_5 = _lrc_nodes_head(frml_1);
  } 
  else {
     cell_5 = _lrc_nodes_nth_elem(_lrc_nodes_tail(frml_1),(frml_2)-(1));
  }
  return(cell_5);
}

static lrc_term _lrc_uat_child(lrc_term frml_1, int frml_2)
{
  lrc_term cell_6;

  if (LRC_TAG(frml_1)==T__LRC_UAT_NO) {
     cell_6 = frml_1;
  } else {
     if (LRC_TAG(frml_1)==T__LRC_UAT_A) {
       cell_6 = C_LRC_UAT_NO();
     } else {
        cell_6 = _lrc_nodes_nth_elem(LRC_CHILD(frml_1,1),frml_2);
       }
  }
  return(cell_6);
}


static lrc_term _lrc_attrs_tail(lrc_term frml_1)
{ lrc_term cell_0;

  if (LRC_TAG(frml_1)==T__LRC_ATTRS2) {
    cell_0 = LRC_CHILD(frml_1,2);
  } else {
    cell_0 = C_LRC_ATTRS0();
  }
  return (cell_0);
}

lrc_term _lrc_node_attrs(lrc_term frml_1)
{ lrc_term cell_1;

  if (LRC_TAG(frml_1)==T__LRC_UAT_A) {
    cell_1 = LRC_CHILD(frml_1,1);
  } else {
   if (LRC_TAG(frml_1)==T__LRC_UAT_CA) {
     cell_1 = LRC_CHILD(frml_1,2);
   } else {
     cell_1 = C_LRC_ATTRS0();
   }
}
return(cell_1);
}

static void report_undefined_prod(char * prod_id) {
   printf("The production %s is not defined in the attribute grammar.\n",prod_id);
}

static lrc_term dt_get_view_uat(DecoratedTerm dt, lrc_string view_name) {
  lrc_term * deco;
  lrc_term res;

  res=0;

  deco=dt_get_decoration(dt);
  if (deco!=0) {
    lrc_string uat_name;
    int        uat_index;

    uat_name  = lrc_string_concat("_lrc_uat_",view_name);
    uat_index = lrc_attr_get_op_index( lrc_prod_lhs_nont(LRC_TAG(dt->ast)), 1, uat_name );
    if (uat_index!=-1) {
      res = deco[uat_index];
    }
  }
  return res;
}


void vi_unparse_avl(AVL_tp a, ViewInstance vi, lrc_term uat);

void vi_unparse_term_internal(lrc_term t, ViewInstance vi, lrc_term uat) {

  int tag;
  int num_children;
  lrc_term unparse_attributes;

  tag=LRC_TAG(t);
  num_children = lrc_constructor_num_sons(tag);
  unparse_attributes=_lrc_node_attrs(uat);
  /***
  printf("vi_unparse_internal\n");
  printf("term=\n");
  lrc_term_print_indent(t,1); printf("\n");
  printf("uat=\n");
  lrc_term_print_indent(uat,1); printf("\n");
  ***/
  if (lrc_is_primitive(t)) {
    if (tag==T__Int) fr_add_constant_string(INTtoSTR(LRC_VALUE_int(t)),vi->fragments);
    if (tag==T__Ptr) fr_add_constant_string(PTRtoSTR(LRC_VALUE_lrc_ptr(t)),vi->fragments);
    if (tag==T__Str) interprete_term_string(t,vi->fragments);
    if (tag==T__Char) interprete_term_string(t,vi->fragments);
    if (tag==T__Map) { lrc_map m;
                       m=LRC_VALUE_lrc_map(t);
                       fr_add_constant_char('[',vi->fragments);
                       vi_unparse_avl(m.avl,vi,uat);
                       fr_add_constant_char(']',vi->fragments);
                     }


    if (tag==T__Real) {
      lrc_real r;
      r=LRC_VALUE_lrc_real(t);
      if (r<0) {
        fr_add_constant_char('-',vi->fragments);
        r=-r;
      }
      fr_add_constant_string(REALtoSTR(r),vi->fragments);
    }

  }
  else if (!lrc_prod_has_unparsing(vi->view_table,tag)) {
    /* unparse the children */
    int child_index;
    for (child_index=1;child_index<=num_children;child_index++) {
      fr_add_child(child_index,vi->fragments);
      vi_unparse_term_internal(LRC_CHILD(t,child_index),vi,_lrc_uat_child(uat,child_index));
    }

  }
  else {
    unparse_commands_entry_tp command_entry;
    unparse_command_tp command;
    int command_number;
    int num_commands;
    int command_index;
    int child_index;         /* Which child are we unparsing, counting childs starts at 1 */
    int unparse_child_index; /* Counts the children that have an unparsing, i.e all except those with .. commands */
    int skip_command; /* skip commands (used to handle chain-commands) */

    skip_command=0;
    child_index=1;
    unparse_child_index=1;
    command_number=1;
    command_index=lrc_prod_first_command_index(vi->view_table,tag);
    num_commands=lrc_prod_num_commands(vi->view_table,tag);
    while(command_number<=num_commands) {
      command_entry=lrc_prod_nth_command(vi->view_table,tag,command_number);
      command_number++;
      command=command_entry.command;
      if (skip_command) {
         if (command==unparse_chain_command_end) skip_command=0;
      }
      else {
        switch(command) {
           case unparse_open_command:
           break;

           case unparse_child_command:
             if (child_index<=num_children) {
               fr_add_child(child_index,vi->fragments);
               vi_unparse_term_internal(LRC_CHILD(t,child_index),vi,_lrc_uat_child(uat,unparse_child_index));
               child_index++;
               unparse_child_index++;
             }
             else { /* this should not happen */
               fr_add_constant_string("unparser:no such child",vi->fragments);
               printf("TAG=%d;child_index=%d;num_children=%d\n",tag,child_index,num_children);
             }
           break;

           case unparse_skip_child_command:
             child_index++; 
           break;

           case unparse_attr_command:
            { lrc_term attr;
              {  lrc_term res;
                 res=0;
                 if (unparse_attributes!=0) {
                   /*
                      printf("Get an unparse attr from\n");
                      lrc_term_print_indent(unparse_attributes,2); printf("\n");
                    */
                   
                   if (lrc_constructor_num_sons(LRC_TAG(unparse_attributes))==2) {
                      res=LRC_VALUE_lrc_ptr(LRC_CHILD(unparse_attributes,1));
                      unparse_attributes=LRC_CHILD(unparse_attributes,2);
                   }
                   else {
                     unparse_attributes=0;
                     res=0;
                   }
                     /*
                      printf("<get_unparse_attr:");
                     if (res==0) printf("0"); else lrc_term_print_long(res);
                     printf(">");
                     */
                 }
                 attr=res;
              }


              if (attr==0) {
                /** fr_add_constant_string("<attr???>",vi->fragments); **/
              }
              else {
               fr_add_enter_attr(vi->fragments); vi_unparse_term_internal(attr,vi,C_LRC_UAT_NO());
              }
            }
           break;

           case unparse_str_command:
             interprete_template_string(command_index,command_entry.command_data,vi->fragments);
           break;

           case unparse_chain_command_start:
             skip_command
             =!(lrc_constructor_num_sons(tag)==2 && lrc_constructor_num_sons(LRC_TAG(LRC_CHILD(t,2)))==2);
           break;

           case unparse_chain_command_end:
             skip_command=0;
           break;
               
        }
      }
      command_index++;
    }

  }
  fr_add_up(vi->fragments);
}

void vi_unparse_term(lrc_term t, ViewInstance vi, lrc_term uat) {
  if (uat==0) uat=C_LRC_UAT_NO();
  vi_unparse_term_internal(t,vi,uat);
}

void vi_unparse_avl(AVL_tp a, ViewInstance vi, lrc_term uat) {
  if (a!=0) {
     vi_unparse_avl(a->left,vi,uat);
     vi_unparse_term_internal(a->key,vi,uat);
     fr_add_constant_string("|->",vi->fragments);
     vi_unparse_term_internal(a->value,vi,uat);
     fr_add_line_break(vi->fragments);
     vi_unparse_avl(a->right,vi,uat);
  }
}



int vi_create_fragments(ViewInstance vi) {
  lrc_term term;
  if (vi==0) return 0;
  if (vi->term_ref==0) return 0;
  output_state=os_plain;
  term=reference_to_term(vi->term_ref);

  TRACE_START
    printf("CREATE FRAGMENTS: term is ");
    if (term==0) printf("<null>"); else lrc_term_print_indent(term,1);
    printf("\n");
    printf("Attributes are:\n");
    if (vi->attributes==0) printf("<null>"); else lrc_term_print_indent(vi->attributes,1);
    printf("\n");
  TRACE_END

  vi_clear_unparsing(vi);
  vi_unparse_term(term,vi,vi->attributes);
  return 1;
}

ViewInstance unparse_descriptor_to_vi(UnparseDescriptor ud) {
  ViewInstance vi;

  vi=create_view_instance();
  vi_enter_term(vi,ud.term);
  vi_set_view(vi,lrc_view_data(ud.view_name));
  vi_set_attributes(vi,ud.uat);

  return vi;
}

void init_unparser(void) {
 int result=1;
 define_tag(_LRC_ATTRS0)
 define_tag(_LRC_ATTRS2)
 define_tag(_LRC_NODES0)
 define_tag(_LRC_NODES2)
 define_tag(_LRC_UAT_A)
 define_tag(_LRC_UAT_C)
 define_tag(_LRC_UAT_CA)
 define_tag(_LRC_UAT_NO)
 if (result!=1) {
   printf("The grammar fails to define one or more productions that are essential\n");
   printf(" for the execution of the editor.\n");
   printf("These productions are normally defined in the prelude.\n\n");
 }
}

lrc_term uat_apply_path(lrc_term uat, Path p) {
  lrc_term t;
  if (p==0) return uat; /* path is root */

  t=uat;
  while(p!=0 && p->childnumber!=0) {
    /** if (lrc_constructor_num_sons(LRC_TAG(t)) < p->childnumber) return 0; **/
    t=_lrc_uat_child(t,p->childnumber);
    p=p->next;
  }
  return t;
}

UnparseDescriptor dt_sr_view2unparse_descriptor
( DecoratedTerm dt,
  Reference ref,
  lrc_string view_name
)
{
  UnparseDescriptor res;
  lrc_term unparse_attrs;

  res.term=reference_to_term(reference_deref(ref));
  res.view_name=view_name;

  res.uat=0;
  if (ref!=0 && ref->tree==dt->ast) { /* A subtree of the decorated tree: obtain attributes. */
    unparse_attrs=dt_get_view_uat(dt,view_name);
    if (unparse_attrs!=0 && ref!=0) {
      /****
        printf("uat_apply_path\n");
        printf("path is "); path_print(ref->sub0); printf("\n");
        printf("unparse attrs=\n");
        lrc_term_print_indent(unparse_attrs,2);
      ****/
      res.uat=uat_apply_path(unparse_attrs, ref->sub0);
      /***
       printf("result of uat_apply_path is\n");
       lrc_term_print_indent(res.uat,2); printf("\n");
       printf("-----------------------------------------------\n\n");
      ***/
    }
  }
  return res;
}


