#ifndef H_UNPARSER
#define H_UNPARSER
typedef enum {
   os_plain, os_after_percent, os_after_ps, os_after_pso
} output_state_tp;

typedef struct unparse_descriptor {
  lrc_term   term;       /* The term that must be unparsed */
  lrc_term   uat;        /* The attributes in the the unparsing of term */
  lrc_string view_name;  /* The name of the textual view */
} UnparseDescriptor;


void unparser_install_attributes(lrc_term ual, char * name);

void unparser_init_text_styles(void);
void unparser_add_style(Style st);
StyleList unparser_get_text_styles(void);
Style unparser_obtain_text_style(lrc_string style_name);

int vi_create_fragments(ViewInstance vi);


ViewInstance unparse_descriptor_to_vi(UnparseDescriptor ud);


void init_unparser(void);

lrc_term uat_apply_path(lrc_term uat, Path p);

UnparseDescriptor dt_sr_view2unparse_descriptor
( DecoratedTerm dt,
  Reference ref,
  lrc_string view_name
);

#endif

